<?php
namespace Bushelpowered\Api\Platform\Branding\V1\Response;
        
class BrandResponse implements \Bushelpowered\Api\Common\HasTimestamps
{
    public string $id;
    public string $flavorId;
    public string $colorPrimary;
    public string $colorSecondary;
    public ?string $launcherUrl = null;
    public ?string $iosAppIconUrl = null;
    public ?string $logoIdUrl = null;
    public ?string $logoStackedUrl = null;
    public ?string $iosSplashScreenUrl = null;
    public bool $hideBushelBranding;
    /** @var string $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;
    /** @var null|string $deletedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $deletedAt = null;

    /**
     * @param  string  $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $deletedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, string $flavorId, string $colorPrimary, string $colorSecondary, ?string $launcherUrl, ?string $iosAppIconUrl, ?string $logoIdUrl, ?string $logoStackedUrl, ?string $iosSplashScreenUrl, bool $hideBushelBranding, string $createdAt, string $updatedAt, ?string $deletedAt)
    {
        $this->id = $id;
        $this->flavorId = $flavorId;
        $this->colorPrimary = $colorPrimary;
        $this->colorSecondary = $colorSecondary;
        $this->launcherUrl = $launcherUrl;
        $this->iosAppIconUrl = $iosAppIconUrl;
        $this->logoIdUrl = $logoIdUrl;
        $this->logoStackedUrl = $logoStackedUrl;
        $this->iosSplashScreenUrl = $iosSplashScreenUrl;
        $this->hideBushelBranding = $hideBushelBranding;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
        $this->deletedAt = $deletedAt;
    }
    
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
    /**
     * @return null|string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getDeletedAt(): ?string
    {
        return $this->deletedAt;
    }
}