<?php
namespace Bushelpowered\Api\Platform\Location\V1\Request;
        
class FacilityRequest implements \Bushelpowered\Api\Platform\Location\V1\Request\HasLocationType
{
    public string $physicalAddressLine1;
    public string $physicalLocality;
    public string $physicalAdministrativeArea;
    public string $physicalPostalCode;
    public string $physicalCountryCode;
    public string $businessPhone;
    public string $datasourceId;
    public string $integrationId;
    public string $sourceId;
    public ?string $sourceName = null;
    public ?string $internalName = null;
    public string $publicName;
    public ?string $physicalAddressLine2 = null;
    public ?float $latitude = null;
    public ?float $longitude = null;
    public ?string $businessEmail = null;
    public ?string $businessWebsite = null;

    /**
     */
    public function __construct(string $physicalAddressLine1, string $physicalLocality, string $physicalAdministrativeArea, string $physicalPostalCode, string $physicalCountryCode, string $businessPhone, string $datasourceId, string $integrationId, string $sourceId, ?string $sourceName, ?string $internalName, string $publicName, ?string $physicalAddressLine2, ?float $latitude, ?float $longitude, ?string $businessEmail, ?string $businessWebsite)
    {
        $this->physicalAddressLine1 = $physicalAddressLine1;
        $this->physicalLocality = $physicalLocality;
        $this->physicalAdministrativeArea = $physicalAdministrativeArea;
        $this->physicalPostalCode = $physicalPostalCode;
        $this->physicalCountryCode = $physicalCountryCode;
        $this->businessPhone = $businessPhone;
        $this->datasourceId = $datasourceId;
        $this->integrationId = $integrationId;
        $this->sourceId = $sourceId;
        $this->sourceName = $sourceName;
        $this->internalName = $internalName;
        $this->publicName = $publicName;
        $this->physicalAddressLine2 = $physicalAddressLine2;
        $this->latitude = $latitude;
        $this->longitude = $longitude;
        $this->businessEmail = $businessEmail;
        $this->businessWebsite = $businessWebsite;
    }
    
    public function getPhysicalAddressLine1(): string
    {
        return $this->physicalAddressLine1;
    }
    public function getPhysicalLocality(): string
    {
        return $this->physicalLocality;
    }
    public function getPhysicalAdministrativeArea(): string
    {
        return $this->physicalAdministrativeArea;
    }
    public function getPhysicalPostalCode(): string
    {
        return $this->physicalPostalCode;
    }
    public function getPhysicalCountryCode(): string
    {
        return $this->physicalCountryCode;
    }
    public function getBusinessPhone(): string
    {
        return $this->businessPhone;
    }
    public function getDatasourceId(): string
    {
        return $this->datasourceId;
    }
    public function getIntegrationId(): string
    {
        return $this->integrationId;
    }
    public function getSourceId(): string
    {
        return $this->sourceId;
    }
    public function getSourceName(): ?string
    {
        return $this->sourceName;
    }
    public function getInternalName(): ?string
    {
        return $this->internalName;
    }
    public function getPublicName(): string
    {
        return $this->publicName;
    }
    public function getPhysicalAddressLine2(): ?string
    {
        return $this->physicalAddressLine2;
    }
    public function getLatitude(): ?float
    {
        return $this->latitude;
    }
    public function getLongitude(): ?float
    {
        return $this->longitude;
    }
    public function getBusinessEmail(): ?string
    {
        return $this->businessEmail;
    }
    public function getBusinessWebsite(): ?string
    {
        return $this->businessWebsite;
    }
}