<?php
namespace Bushelpowered\Api\Trade\Offers\V1\Request;
        
class ESignSignedRequest 
{
    public string $datasourceId;
    public string $tenantId;
    public string $contractSourceId;
    public string $contractSourceDisplayId;
    public string $contractSourceCustomerId;
    public string $contractSourceCommodityId;
    public string $email;
    public string $message;
    public string $subject;
    public string $title;
    public bool $hasError;
    public bool $isTest;
    /** @var null|string $archivedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $archivedAt = null;
    /** @var null|string $completedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $completedAt = null;
    /** @var string $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var null|string $declinedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $declinedAt = null;
    /** @var null|string $invalidAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $invalidAt = null;
    /** @var null|string $pendingAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $pendingAt = null;

    /**
     * @param  null|string  $archivedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $completedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $declinedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $invalidAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $pendingAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $datasourceId, string $tenantId, string $contractSourceId, string $contractSourceDisplayId, string $contractSourceCustomerId, string $contractSourceCommodityId, string $email, string $message, string $subject, string $title, bool $hasError, bool $isTest, ?string $archivedAt, ?string $completedAt, string $createdAt, ?string $declinedAt, ?string $invalidAt, ?string $pendingAt)
    {
        $this->datasourceId = $datasourceId;
        $this->tenantId = $tenantId;
        $this->contractSourceId = $contractSourceId;
        $this->contractSourceDisplayId = $contractSourceDisplayId;
        $this->contractSourceCustomerId = $contractSourceCustomerId;
        $this->contractSourceCommodityId = $contractSourceCommodityId;
        $this->email = $email;
        $this->message = $message;
        $this->subject = $subject;
        $this->title = $title;
        $this->hasError = $hasError;
        $this->isTest = $isTest;
        $this->archivedAt = $archivedAt;
        $this->completedAt = $completedAt;
        $this->createdAt = $createdAt;
        $this->declinedAt = $declinedAt;
        $this->invalidAt = $invalidAt;
        $this->pendingAt = $pendingAt;
    }
    

}